blob: 9aedf3c09fea770b7b2229a5fa726f9fccb468a4 [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
6# http://nvie.com/archives/323
7#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
11# Copyright (c) 2010 by Vincent Driessen
12# Copyright (c) 2010 by Benedikt Böhm
13#
14
Vincent Driessend72e4ac2010-02-16 21:33:51 +010015gitflow_require_git_repo
Vincent Driessenc1598bf2010-02-20 16:52:48 +010016gitflow_require_initialized
Vincent Driessend72e4ac2010-02-16 21:33:51 +010017gitflow_load_settings
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010018VERSION_PREFIX=$(git config --get gitflow.prefix.versiontag)
Vincent Driessenc1598bf2010-02-20 16:52:48 +010019PREFIX=$(git config --get gitflow.prefix.release)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010020
Benedikt Böhm00ccea62010-01-26 12:39:36 +010021usage() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010022 echo "usage: git flow release [list] [-v]"
Vincent Driessen170dc742010-01-28 00:20:51 +010023 echo " git flow release start <version>"
24 echo " git flow release finish <version>"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010025 # TODO
26 #echo ""
27 #echo "options:"
28 #echo "--option Explanation"
29 #echo ""
30 #echo "start-only options:"
31 #echo "--bump <script>"
32 #echo " Run the given script to auto-update the version number"
33 #echo ""
34 #echo "finish-only options:"
35 #echo "--push Push to the origin repo when finished"
36}
37
Vincent Driessen170dc742010-01-28 00:20:51 +010038cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010039 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010040}
41
Vincent Driessenb866b012010-01-28 01:01:53 +010042cmd_list() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010043 DEFINE_boolean verbose false 'verbose (more) output' v
44 parse_args "$@"
45
Vincent Driessenf46e2902010-02-15 23:01:52 +010046 local release_branches
47 local current_branch
48 local short_names
Vincent Driessen21c7aa92010-02-16 20:57:35 +010049 release_branches=$(echo "$(gitflow_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010050 if [ -z "$release_branches" ]; then
Vincent Driessen170dc742010-01-28 00:20:51 +010051 warn "No release branches exist."
52 exit 0
53 fi
Vincent Driessen3c337fb2010-02-04 11:30:18 +010054
Vincent Driessen27592dd2010-02-06 14:45:39 +010055 current_branch=$(git branch | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen68845232010-02-10 00:43:21 +010056 short_names=$(echo "$release_branches" | sed "s ^$PREFIX g")
Vincent Driessen27592dd2010-02-06 14:45:39 +010057
Vincent Driessen3c337fb2010-02-04 11:30:18 +010058 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010059 local width=0
60 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010061 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010062 local len=${#branch}
Vincent Driessen3c337fb2010-02-04 11:30:18 +010063 width=$(max $width $len)
64 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010065 width=$(($width+3))
Vincent Driessen3c337fb2010-02-04 11:30:18 +010066
Vincent Driessenf46e2902010-02-15 23:01:52 +010067 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010068 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010069 local fullname=$PREFIX$branch
70 local base=$(git merge-base "$fullname" "$DEVELOP_BRANCH")
71 local develop_sha=$(git rev-parse "$DEVELOP_BRANCH")
72 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010073 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +010074 printf "* "
75 else
76 printf " "
77 fi
78 if flag verbose; then
79 printf "%-${width}s" "$branch"
80 if [ "$branch_sha" = "$develop_sha" ]; then
81 printf "(no commits yet)"
82 else
Vincent Driessenf46e2902010-02-15 23:01:52 +010083 local nicename=$(git rev-parse --short "$base")
Vincent Driessen3c337fb2010-02-04 11:30:18 +010084 printf "(based on $nicename)"
85 fi
86 else
87 printf "%s" "$branch"
88 fi
89 echo
90 done
Vincent Driessen170dc742010-01-28 00:20:51 +010091}
92
Benedikt Böhm00ccea62010-01-26 12:39:36 +010093cmd_help() {
94 usage
95 exit 0
96}
97
Vincent Driessenb866b012010-01-28 01:01:53 +010098parse_args() {
Vincent Driessen3c337fb2010-02-04 11:30:18 +010099 # parse options
100 FLAGS "$@" || exit $?
101 eval set -- "${FLAGS_ARGV}"
102
103 # read arguments into global variables
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100104 VERSION=$1
105 BRANCH=$PREFIX$VERSION
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100106}
107
108require_version_arg() {
Vincent Driessenb866b012010-01-28 01:01:53 +0100109 if [ "$VERSION" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100110 warn "Missing argument <version>"
Vincent Driessenb866b012010-01-28 01:01:53 +0100111 usage
112 exit 1
113 fi
Vincent Driessenb866b012010-01-28 01:01:53 +0100114}
115
Vincent Driessen010252a2010-02-04 10:31:29 +0100116require_base_is_on_develop() {
117 if ! git branch --contains "$BASE" 2>/dev/null \
118 | sed 's/[* ] //g' \
119 | grep -q "^$DEVELOP_BRANCH\$"; then
120 die "fatal: Given base '$BASE' is not a valid commit on '$DEVELOP_BRANCH'."
121 fi
122}
123
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100124require_no_existing_release_branches() {
Vincent Driessen21c7aa92010-02-16 20:57:35 +0100125 local release_branches=$(echo "$(gitflow_local_branches)" | grep "^$PREFIX")
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100126 local first_branch=$(echo ${release_branches} | head -n1)
127 first_branch=${first_branch#$PREFIX}
128 [ -z "$release_branches" ] || \
129 die "There is an existing release branch ($first_branch). Finish that one first."
130}
131
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100132cmd_start() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100133 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100134 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100135 BASE=${2:-$DEVELOP_BRANCH}
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100136 require_version_arg
Vincent Driessen010252a2010-02-04 10:31:29 +0100137 require_base_is_on_develop
Vincent Driessen6d64d2c2010-02-16 06:41:13 +0100138 require_no_existing_release_branches
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100139
140 # sanity checks
Vincent Driessen48386442010-01-29 10:30:40 +0100141 gitflow_require_clean_working_tree
Vincent Driessena4dd2232010-02-10 00:34:59 +0100142 gitflow_require_branch_absent "$BRANCH"
143 gitflow_require_tag_absent "$VERSION_PREFIX$VERSION"
Vincent Driessenca73caf2010-02-07 19:46:38 +0100144 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100145 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH"
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100146 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100147 gitflow_require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100148
149 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100150 git checkout -b "$BRANCH" "$BASE"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100151
152 echo
153 echo "Summary of actions:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100154 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100155 echo "- You are now on branch '$BRANCH'"
156 echo
157 echo "Follow-up actions:"
158 echo "- Bump the version number now!"
159 echo "- Start committing last-minute fixes in preparing your release"
160 echo "- When done, run:"
161 echo
Vincent Driessen010252a2010-02-04 10:31:29 +0100162 echo " git flow release finish '$VERSION'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100163 echo
164}
165
166cmd_finish() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100167 DEFINE_boolean fetch true "fetch from $ORIGIN before performing finish" F
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100168 DEFINE_boolean sign false "sign the release tag cryptographically" s
169 DEFINE_string signingkey "" "use the given GPG-key for the digital signature (implies -s)" u
170 DEFINE_string message "" "use the given tag message" m
Vincent Driessenddba2df2010-02-19 06:42:18 +0100171 DEFINE_boolean push false "push to $ORIGIN after performing finish" p
Jason L. Shiffer6809f0e2010-02-18 23:57:08 -0500172
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100173 parse_args "$@"
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100174 require_version_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100175
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100176 # handle flags that imply other flags
177 if [ "$FLAGS_signingkey" != "" ]; then
178 FLAGS_sign=$FLAGS_TRUE
179 fi
180
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100181 # sanity checks
Vincent Driessena4dd2232010-02-10 00:34:59 +0100182 gitflow_require_branch "$BRANCH"
Vincent Driessen48386442010-01-29 10:30:40 +0100183 gitflow_require_clean_working_tree
Vincent Driessenca73caf2010-02-07 19:46:38 +0100184 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100185 git fetch -q "$ORIGIN" "$MASTER_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100186 die "Could not fetch $MASTER_BRANCH from $ORIGIN."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100187 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH" || \
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100188 die "Could not fetch $DEVELOP_BRANCH from $ORIGIN."
Vincent Driessen2acfffd2010-01-29 12:37:22 +0100189 fi
Vincent Driessena4dd2232010-02-10 00:34:59 +0100190 gitflow_require_branches_equal "$MASTER_BRANCH" "$ORIGIN/$MASTER_BRANCH"
191 gitflow_require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100192
Vincent Driessen5fa47582010-02-09 00:31:33 +0100193 # try to merge into master
194 # in case a previous attempt to finish this release branch has failed,
195 # but the merge into master was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100196 if ! gitflow_is_branch_merged_into "$BRANCH" "$MASTER_BRANCH"; then
197 git checkout "$MASTER_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100198 die "Could not check out $MASTER_BRANCH."
Vincent Driessena4dd2232010-02-10 00:34:59 +0100199 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100200 die "There were merge conflicts."
201 # TODO: What do we do now?
202 fi
Vincent Driessen1a2868b2010-02-07 23:23:16 +0100203
Vincent Driessen5fa47582010-02-09 00:31:33 +0100204 # try to tag the release
205 # in case a previous attempt to finish this release branch has failed,
206 # but the tag was set successful, we skip it now
Vincent Driessenf46e2902010-02-15 23:01:52 +0100207 local tagname=$VERSION_PREFIX$VERSION
Vincent Driessena4dd2232010-02-10 00:34:59 +0100208 if ! gitflow_tag_exists "$tagname"; then
Vincent Driessenf46e2902010-02-15 23:01:52 +0100209 local opts="-a"
Vincent Driessen5fa47582010-02-09 00:31:33 +0100210 flag sign && opts="$opts -s"
211 [ "$FLAGS_signingkey" != "" ] && opts="$opts -u '$FLAGS_signingkey'"
212 [ "$FLAGS_message" != "" ] && opts="$opts -m '$FLAGS_message'"
213 git tag $opts "$tagname" || \
214 die "Tagging failed. Please run finish again to retry."
215 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100216
Vincent Driessen5fa47582010-02-09 00:31:33 +0100217 # try to merge into develop
218 # in case a previous attempt to finish this release branch has failed,
219 # but the merge into develop was successful, we skip it now
Vincent Driessena4dd2232010-02-10 00:34:59 +0100220 if ! gitflow_is_branch_merged_into "$BRANCH" "$DEVELOP_BRANCH"; then
221 git checkout "$DEVELOP_BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100222 die "Could not check out $DEVELOP_BRANCH."
Vincent Driessend29e3152010-02-09 00:55:06 +0100223
224 # TODO: Actually, accounting for 'git describe' pays, so we should
225 # ideally git merge --no-ff $tagname here, instead!
Vincent Driessena4dd2232010-02-10 00:34:59 +0100226 git merge --no-ff "$BRANCH" || \
Vincent Driessen5fa47582010-02-09 00:31:33 +0100227 die "There were merge conflicts."
228 # TODO: What do we do now?
229 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100230
231 # delete branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100232 git branch -d "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100233
Vincent Driessenddba2df2010-02-19 06:42:18 +0100234 if flag push; then
235 git push "$ORIGIN" "$DEVELOP_BRANCH" || \
236 die "Could not push to $DEVELOP_BRANCH from $ORIGIN."
237 git push "$ORIGIN" "$MASTER_BRANCH" || \
238 die "Could not push to $MASTER_BRANCH from $ORIGIN."
239 git push --tags "$ORIGIN" || \
240 die "Could not push tags to $ORIGIN."
241 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100242
243 echo
244 echo "Summary of actions:"
Benedikt Böhm350e7152010-01-26 13:05:05 +0100245 echo "- Latest objects have been fetched from '$ORIGIN'"
Benedikt Böhm4a864fb2010-01-26 12:59:27 +0100246 echo "- Release branch has been merged into '$MASTER_BRANCH'"
Vincent Driessen5fa47582010-02-09 00:31:33 +0100247 echo "- The release was tagged '$tagname'"
Benedikt Böhm4a864fb2010-01-26 12:59:27 +0100248 echo "- Release branch has been back-merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100249 echo "- Release branch '$BRANCH' has been deleted"
Vincent Driessenddba2df2010-02-19 06:42:18 +0100250 if flag push; then
251 echo "- '$DEVELOP_BRANCH', '$MASTER_BRANCH' and tags have been pushed to '$ORIGIN'"
252 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100253 echo
254}